<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item label="" prop="deviceName">
        <el-select
          v-model="queryParams.deviceName"
          placeholder="水泵名称"
          clearable
        >
          <el-option
            v-for="dict in devList"
            :key="dict.name"
            :label="dict.name"
            :value="dict.name"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
      </el-form-item>
    </el-form>

    <el-table
      v-loading="loading"
      :data="historyList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column label="水泵名称" align="center" prop="pumpName" />
      <el-table-column label="水泵编号" align="center" prop="pumpId" />
      <el-table-column
        label="水泵安装位置"
        align="center"
        prop="installationLocation"
      />
      <el-table-column label="水泵前温" align="center" prop="pumpFrontTemp" />
      <el-table-column label="水泵后温" align="center" prop="pumpRearTemp" />
      <el-table-column label="电机前温" align="center" prop="motorFrontTemp" />
      <el-table-column label="电机后温" align="center" prop="motorRearTemp" />
      <el-table-column label="出水压力" align="center" prop="outletPressure" />
      <el-table-column label="吸水负压" align="center" prop="inletVacuum" />
      <el-table-column label="前振动" align="center" prop="frontVibrate" />
      <el-table-column label="后振动" align="center" prop="rearVibration" />
      <el-table-column
        label="监测时间"
        align="center"
        prop="monitoringTime"
        width="180"
      >
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.monitoringTime) }}</span>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
  </div>
</template>

<script>
import { getHistory, listHistory } from "@/api/tyler/waterPumpShishiData";
import { draDeviceName } from "@/api/tyler/common";

export default {
  name: "History",
  data() {
    return {
      // 根路径
      baseURL: process.env.VUE_APP_BASE_API,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 水泵历史信息表格数据
      historyList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        pumpId: null,
        pumpName: null,
        pumpFrontTemp: null,
        pumpRearTemp: null,
        motorFrontTemp: null,
        motorRearTemp: null,
        outletPressure: null,
        inletVacuum: null,
        monitoringTime: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
      // 日期范围
      dateRange: [],
      devList: [],
    };
  },
  created() {
    draDeviceName({ typeId: 1 }).then((res) => {
      this.devList = res.data;
    });
    this.getList();
  },
  methods: {
    /** 查询水泵历史信息列表 */
    getList() {
      this.loading = true;
      listHistory(this.addDateRange(this.queryParams, this.dateRange)).then(
        (response) => {
          this.historyList = response.rows;
          this.total = response.total;
          this.loading = false;
        }
      );
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        pumpId: null,
        pumpName: null,
        pumpFrontTemp: null,
        pumpRearTemp: null,
        motorFrontTemp: null,
        motorRearTemp: null,
        outletPressure: null,
        inletVacuum: null,
        monitoringTime: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加水泵历史信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getHistory(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改水泵历史信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateHistory(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addHistory(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除水泵历史信息编号为"' + ids + '"的数据项？')
        .then(function () {
          return delHistory(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "business/history/export",
        {
          ...this.queryParams,
        },
        `history_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
